package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import jakarta.persistence.*
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull

@Entity
data class AppText (
    @Expose @Id @GeneratedValue(strategy = GenerationType.IDENTITY) @get: NonNull var textId: Long = 0,
    @Expose @get: NonNull var textKey: String,
    @Expose @get: NonNull var screenshotUrl: String,
    @Expose @get: NonNull var checked: Boolean? = null,
) {
    @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "appText")
    @Fetch(value = FetchMode.SUBSELECT)
    @Expose val translations: List<AppTextTranslation> = mutableListOf<AppTextTranslation>().toList()

}