package com.aitrainer.api.model.diet
import com.google.gson.annotations.Expose
import jakarta.persistence.*
import org.jetbrains.annotations.NotNull

@Entity
data class Meal (
    @Id @GeneratedValue(strategy = GenerationType.IDENTITY) @Expose val id: Long = 0,

    @Expose @get: NotNull val name: String = "",
    @Expose @get: NotNull var normalizedName: String = "",
    @Expose @get: NotNull val quantity: Double = 0.0,
    @Expose @get: NotNull val quantityUnit: String = "",
    @Expose @get: NotNull var serving: Double = 0.0,
    @Expose @get: NotNull var servingUnit: String = "",
    @Expose @get: NotNull val description: String = "",
    @Expose @get: NotNull val calMin:  Double = 0.0,
    @Expose @get: NotNull val calMax:  Double = 0.0,
    @Expose @get: NotNull val proteinMin:  Double = 0.0,
    @Expose @get: NotNull val proteinMax:  Double = 0.0,
    @Expose @get: NotNull val fatMin:  Double = 0.0,
    @Expose @get: NotNull val fatMax:  Double = 0.0,
    @Expose @get: NotNull val chMin:  Double = 0.0,
    @Expose @get: NotNull val chMax:  Double = 0.0,
    @Expose @get: NotNull val sugar:  Double = 0.0,
)