package com.aitrainer.api.test

import com.aitrainer.api.controller.CustomerMembershipController
import com.aitrainer.api.repository.CustomerMembershipRepository
import com.aitrainer.api.repository.CustomerRepository
import com.google.gson.Gson
import org.junit.jupiter.api.Test
import org.junit.jupiter.api.TestInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc
import org.springframework.boot.test.context.SpringBootTest
import org.springframework.test.web.servlet.MockMvc
import kotlin.test.assertEquals
import kotlin.test.assertTrue

@SpringBootTest
@AutoConfigureMockMvc
@TestInstance(TestInstance.Lifecycle.PER_CLASS)
class CustomerMembershipTest {

    @Autowired
    private lateinit var customerMembershipRepository: CustomerMembershipRepository

    @Autowired
    lateinit var customerRepository: CustomerRepository

    @Autowired
    private lateinit var mockMvc: MockMvc


    @Test
    fun testCustomerMembershipByCustomerId() {
        val controller = CustomerMembershipController(customerMembershipRepository, customerRepository )
        val response = controller.getAllByCustomerId(90)

        val properties = response.body

        assertTrue(properties is List)
        assertTrue(properties.isNotEmpty())
        assertEquals(properties.size, 2)
    }

    @Test
    fun testInsert() {
        /* val authToken = Tokenizer.getToken()
         val foundCustomer: Customer? = customerRepository.findByCustomerIdAndActive(90, "Y")

         val customerMembership = CustomerMembership(
             membershipId = 3,
             startDate = "2023-01-30",
         )
         customerMembership.customer = foundCustomer

         mockMvc.perform(
             MockMvcRequestBuilders.post("/api/customer_membership")
                 .contentType(MediaType.APPLICATION_JSON)
                 .header("Authorization", "Bearer $authToken")
                 .content(toJson(customerMembership))
         )
             .andExpect(MockMvcResultMatchers.status().isOk)
             .andExpect(MockMvcResultMatchers.jsonPath("$.membership").value(3))
             .andReturn()

           val foundCustomer: Customer? = customerRepository.findByCustomerIdAndActive(90, "Y")
           val customerMembership = CustomerMembership(
               membershipId = 3,
               startDate = "2023-01-30",
           )
           customerMembership.customer = foundCustomer

           val controller = CustomerMembershipController(customerMembershipRepository, customerRepository)
           val response = controller.createNewCustomerMembership(customerMembership)

           val newCustomerMembership = response.body

           assertTrue(newCustomerMembership is CustomerMembership)
           customerMembershipRepository.delete(newCustomerMembership) // does not delete the customer_membership
           */
    }

    private fun toJson(obj: Any): String {
        val str = Gson().toJson(obj)
        return str
    }
}