package com.aitrainer.api.test

import com.aitrainer.api.controller.PropertyController
import com.aitrainer.api.repository.PropertyRepository
import org.junit.jupiter.api.Test
import org.junit.jupiter.api.TestInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import kotlin.test.assertEquals
import kotlin.test.assertTrue

@SpringBootTest
@TestInstance(TestInstance.Lifecycle.PER_CLASS)
class PropertyTest {

    @Autowired
    private lateinit var propertyRepository: PropertyRepository


    @Test
    fun testGetProperties() {
        val controller = PropertyController(propertyRepository )
        val response = controller.getPropertiesWithTranslation()

        val properties = response.body

        assertTrue(properties is List)
        assertTrue(properties.isNotEmpty())
        assertEquals(properties.size, 7)
        assertEquals(properties[0].propertyName, "Weight")
        assertEquals(properties[0].translations[0].propertyName, "Tömeg")
        assertEquals(properties[1].propertyName, "Height")
    }

}